#pragma once

#include <iostream>
#include <string>
#include <boost/lexical_cast.hpp>
#include <boost/thread.hpp>
#include <boost/circular_buffer.hpp>
#include <boost/function.hpp>

#include "logger.hpp"

#define SERVER_IP "192.167.0.163"
#define SERVER_PORT 3001
#define SERVER_THREADS 10

static boost::mutex globalStreamLock;
#define lock_stream() globalStreamLock.lock()
#define unlock_stream() globalStreamLock.unlock()

typedef struct
{
    std::string tcpbuffer;
    unsigned short port;
} TcpData ;


typedef boost::shared_ptr < TcpData > TcpDataPtr;
typedef boost::circular_buffer< TcpDataPtr > MessageQueueType;

typedef boost::function < void ( const std::string, unsigned short ) > ReceiveCallBackType; 