/// \brief      [Brief description]
///
/// [Detailed description]
///
/// \date       January 12, 2023
/// \copyright  Costar Technologies, Inc.

#ifndef __MESSAGEQUEUE_HPP_
#define __MESSAGEQUEUE_HPP_

#include "common.hpp"

class messagequeue
{
public:

    messagequeue ( )
    : m_messageQueue ( kMaxQueueSize )
    {
    }

    ///
    /// \brief      : Destructor
    ///

    ~messagequeue ( )
    {
        /// clear the queue
        m_messageQueue.clear ( );
    }

    void push ( TcpDataPtr data )
    {
        lock_stream ( );
        LOG_ERR ( ) << " called" << std::endl;
        unlock_stream ( );
        m_mutex.lock ( );
        m_messageQueue.push_back ( data );
        m_mutex.unlock ( );
    }

    TcpDataPtr pop ( )
    {
        lock_stream ( );
        LOG_ERR ( ) << " called" << std::endl;
        unlock_stream ( );
        TcpDataPtr value = nullptr;
        if ( m_messageQueue.empty ( ) )
        {
            lock_stream ( );
            LOG_ERR ( ) << "empty message queue" << std::endl;
            unlock_stream ( );
            return value;
        }
        m_mutex.lock ( );
        value = m_messageQueue.front ( );
        m_messageQueue.pop_front ( );
        m_mutex.unlock ( );
        return value;
    }

private:

    const uint32_t kMaxQueueSize = 10;              ///< Maximum queue size
    MessageQueueType m_messageQueue;                ///< Queue for hodling message session
    boost::mutex m_mutex;

} ;


#endif ///< __MESSAGEQUEUE_HPP_


