/// \brief      [Brief description]
///
/// [Detailed description]
///
/// \date       January 12, 2023
/// \copyright  Costar Technologies, Inc.

#ifndef __HANDLER_HPP_
#define __HANDLER_HPP_

#include <memory>
#include <map>
#include <boost/thread.hpp>

class session;

class handler
{
public:

    typedef std::map < unsigned short, session* > SessionMapType;

    ///
    /// \brief      : Constructor
    ///
    handler ( );

    ///
    /// \brief      : Destructor
    ///
    ~handler ( );



    void AddSession ( const unsigned short &port, session* pSession );

    void RemoveSession ( const unsigned short &port );

    session* GetSession ( const unsigned short &port );


private:
    ///
    /// \brief      : Disable copy constructor by default to prevent shallow copy issues
    ///
    handler ( const handler& ) = delete;



    SessionMapType m_sessionMap;
    boost::mutex m_mutex;

} ;

#endif ///< __HANDLER_HPP_

