#pragma once

#include <boost/asio.hpp>
#include <boost/system/error_code.hpp>
#include "common/messagequeue.hpp"

using boost::asio::ip::tcp;
using boost::system::error_code;

class packet final
{
public:
    packet( ReceiveCallBackType pReceiveFn  ) noexcept;
    ~packet() noexcept;

    error_code recv(tcp::socket &socket) noexcept;
    error_code send(tcp::socket &socket) noexcept;
    error_code process(tcp::socket &socket) noexcept;

private:   
    std::vector < uint8_t > m_dataBuffer; 
    ReceiveCallBackType m_pReceiveFunction;
};
