#pragma once

#include <boost/asio.hpp>
#include <boost/shared_ptr.hpp>
#include <boost/make_shared.hpp>
#include "packet.hpp"
#include "handler.hpp"


using boost::shared_ptr;
using boost::asio::io_service;
using boost::asio::ip::tcp;

class session final
{
public:
    session(shared_ptr<io_service> ios, ReceiveCallBackType pReceiveFn ) noexcept;
    ~session () noexcept;

    void start() noexcept;
    void stop() noexcept;
    void send ();
    void setHandler ( shared_ptr<handler> pHandler );

    tcp::socket &get_socket() noexcept;

private:
    shared_ptr<io_service> m_io_service;
    shared_ptr<handler> m_handler;
    tcp::socket m_socket;
    packet m_packet;
};
